module RND_Extensions

	module RND_Canvas

		class Canvas
			@@model = Sketchup.active_model
			@@path = File.dirname(__FILE__)
			@@rnd_canvas = "rnd_canvas.html"
			@@canvas_dlg = nil

			def initialize()

				@canvas_1_file = File.join(@@path, @@rnd_canvas)

				if (!@canvas_1_file) then
					UI.messagebox("Cannot find file '#{@@rnd_canvas} in folder '#{@@path}'")
					return
				end

				if @@canvas_dlg == nil
					@@canvas_dlg = UI::WebDialog.new("Canvas v1.1.0", false, "Canvas v1.1.0", 280, 555, 70, 25, true)

					@@canvas_dlg.add_action_callback("push_frame") do |d,p|
					push_frame(d,p)
					end
				end

				@@canvas_dlg.set_size(280, 555)
				@@canvas_dlg.set_file(@canvas_1_file)
				@@canvas_dlg.show()

				@@mult_add = true
				@@ip = 0
				@@not_add = false

			end #def



			def push_frame(dialog,data)
				@@canvas_dlg.execute_script("document.body.style.zoom = 0.80")
				params = query_to_hash(data)
				
				#################
				## Input Point ##
				#################
				if params['sel_ip'].to_s == "1"
					@@ip = 0
				end
				if params['sel_ip'].to_s == "2"
					@@ip = 1
				end
				if params['sel_ip'].to_s == "3"
					@@ip = 2
				end
				if params['sel_ip'].to_s == "4"
					@@ip = 3
				end
				if params['sel_ip'].to_s == "5"
					@@ip = 4
				end

				####################
				## Single or Mult ##
				####################
				if params['add_mult'].to_s == "multiple"
					@@mult_add = true
					@@ind_add = false
				else
					@@mult_add = false
					@@ind_add = true
				end

				################# 
				##   Rotate    ##
				#################
				@@rmin = params['rmin'].to_f
				@@rmax = params['rmax'].to_f

				#################
				##    Scale    ##
				#################
				@@smin = params['smin'].to_f
				@@smax = params['smax'].to_f

				#################
				## Empty Space ##
				#################
				if params['add_not'].to_s == "true"
					@@not_add = true
				else
					@@not_add = false
				end

				#################
				##  Selection  ##
				#################
				if params['addon_sel'].to_s == "true"
					@@sel_addon = true
				else
					@@sel_addon = false
				end

				#################
				##   Vertex    ##
				#################
				if params['addon_vertex'].to_s == "true"
					@@vertex_addon = true
					Sketchup.active_model.rendering_options["DrawLineEnds"] = true
				else
					@@vertex_addon = false
					Sketchup.active_model.rendering_options["DrawLineEnds"] = false
				end

				#################
				##     Edge    ##
				#################
				if params['addon_edge'].to_s == "true"
					@@edge_addon = true
				else
					@@edge_addon = false
				end

				#################
				##     Face    ##
				#################
				if params['addon_face'].to_s == "true"
					@@face_addon = true
				else
					@@face_addon = false
				end

				#################
				##    Group    ##
				#################
				if params['addon_group'].to_s == "true"
					@@group_addon = true
				else
					@@group_addon = false
				end

				#################
				##  Component  ##
				#################
				if params['addon_component'].to_s == "true"
					@@component_addon = true
				else
					@@component_addon = false
				end

				#################
				##    Image    ##
				#################
				if params['addon_image'].to_s == "true"
					@@image_addon = true
				else
					@@image_addon = false
				end

				#################
				##   Material  ##
				#################
				if params['addon_material'].to_s == "true"
					@@material_addon = true
				else
					@@material_addon = false
				end

				#################
				##   Texture   ##
				#################
				if params['addon_texture'].to_s == "true"
					@@texture_addon = true
				else
					@@texture_addon = false
				end

				#################
				##    Shadow   ##
				#################
				if params['addon_shadow'].to_s == "true"
					@@shadow_addon = true
				else
					@@shadow_addon = false
				end
				
				dialog.set_on_close{Sketchup.send_action('selectSelectionTool:')}

			end #def



			def unescape(string)
				if string != nil
					string = string.gsub(/\+/, ' ').gsub(/((?:%[0-9a-fA-F]{2})+)/n) do
						[$1.delete('%')].pack('H*')
					end
				end
				return string
			end #def



			def query_to_hash(query)
				param_pairs = query.split('&')
				param_hash = {}
				for param in param_pairs
					name, value = param.split('=')
					name = unescape(name)
					value = unescape(value)
					param_hash[name] = value
				end
				return param_hash
			end #def



			def onMouseMove(flags,x,y,view)
				@@sel = Sketchup.active_model.selection[0]
				@@ents = Sketchup.active_model.active_entities

				if @@ip == 0
					ip1 = view.inputpoint x,y
					view.tooltip = ip1.tooltip #View Tool Tips
				end
				if @@ip == 1
					ip1 = view.inputpoint x+rand(100)-50,y+rand(100)-50 # testing other settings
				end
				#Add::Viewport Top
				if @@ip == 2
				ip1 = view.inputpoint x,y-y ; # testing other settings
				end
				#Add::Viewport Bottom
				if @@ip == 3
				ip1 = view.inputpoint x,y+y ; # testing other settings
				end

				#Add::World
				if @@ip == 4
				c_point = view.screen_coords(ORIGIN)
				ip1 = view.inputpoint c_point.x,c_point.y
				end
				#----------------------------------------------
				#Point
				#----------------------------------------------
				@point = ip1.position
						
				if @@mult_add == true
					# Add:: ALL
					if flags == 1 && @@not_add == false && @@vertex_addon == false && @@edge_addon == false && @@face_addon == false && @@group_addon == false && @@component_addon == false && @@image_addon == false && @@material_addon == false && @@texture_addon == false && @@sel_addon == false && @@shadow_addon == false
						add_object(@point)
					end

					# Add On Shadow
					ipa = view.inputpoint x,y
					pointa = ipa.position
					svec = @@model.shadow_info["SunDirection"]
					hit_patha = Sketchup.active_model.raytest [pointa,svec]

					if flags == 1 &&  hit_patha && @@shadow_addon == true
						add_object(pointa)
					end #if

					# Don't Add:: If Pointer On Face 
					if flags == 1 && @@sel != nil && ip1.face == nil && @@not_add == true
						add_object(@point)
					end

					# Add On Vertex
					if flags == 1 && @@sel != nil && ip1.vertex != nil && @@vertex_addon == true
						add_object(@point)
					end

					# Add On Edge
					if flags == 1 && @@sel != nil && ip1.edge != nil && @@edge_addon == true
						add_object(@point)
					end

					# Add On Face 	
					if flags == 1 && @@sel != nil && ip1.face != nil && @@face_addon == true
						add_object(@point)
					end

					select_comp=view.pick_helper
					select_comp.do_pick x,y
					selected_comp=select_comp.best_picked
					
					selected_face=select_comp.picked_face
					selected_face_mat=selected_face.material

					selection = Sketchup.active_model.selection
					sel_comp_status = selection.contains? selected_comp
					sel_face_status = selection.contains? selected_face

					# Add On Group 	
					if flags == 1 && @@sel != nil && @@group_addon == true && selected_comp.is_a?(Sketchup::Group) == true
						add_object(@point)
					end

					# Add On Component
					if flags == 1 && @@sel != nil && @@component_addon == true && selected_comp.is_a?(Sketchup::ComponentInstance) == true
						add_object(@point)
					end

					# Add On Image 	
					if flags == 1 && @@sel != nil && @@image_addon == true && selected_comp.is_a?(Sketchup::Image) == true
						add_object(@point)
					end

					# Add On Material
					if flags == 1 && @@sel != nil && @@material_addon == true && selected_face_mat != nil
						add_object(@point)
					end

					# Add On Texture
					if flags == 1 && @@sel != nil && @@texture_addon == true && selected_face_mat.texture != nil
						add_object(@point)
					end

					# Add On Selection
					if flags == 1 && @@sel != nil && @@sel_addon == true && sel_face_status == true
						add_object(@point)
					end
					if flags == 1 && @@sel != nil && @@sel_addon == true && sel_comp_status == true
						add_object(@point)
					end

				end

			end #def



			def onLButtonDown(flags,x,y,view)
				@@sel = Sketchup.active_model.selection[0]
				@@ents = Sketchup.active_model.active_entities

				if @@ind_add == true

					if @@ip == 0
						ip1 = view.inputpoint x,y
					end

					if @@ip == 1
						ip1 = view.inputpoint x+rand(100)-50,y+rand(100)-50
					end
					
					@point = ip1.position
					
					# Add:: ALL
					if flags == 1 && @@not_add == false && @@vertex_addon == false && @@edge_addon == false && @@face_addon == false && @@group_addon == false && @@component_addon == false && @@image_addon == false && @@material_addon == false && @@texture_addon == false && @@sel_addon == false && @@shadow_addon == false  
						add_object(@point)
					end

					# Add On Shadow 
					ipa = view.inputpoint x,y
					pointa = ipa.position
					svec = @@model.shadow_info["SunDirection"]
					hit_patha = Sketchup.active_model.raytest [pointa,svec]

					if flags == 1 &&  hit_patha && @@shadow_addon == true
						add_object(pointa)
					end #if

					# Don't Add:: If Pointer On Face 
					if flags == 1 && @@sel != nil && ip1.face == nil && @@not_add == true
						add_object(@point)
					end

					# Add On Vertex
					if flags == 1 && @@sel != nil && ip1.vertex != nil && @@vertex_addon == true
						add_object(@point)
					end

					# Add On Edge
					if flags == 1 && @@sel != nil && ip1.edge != nil && @@edge_addon == true
						add_object(@point)
					end

					# Add On Face 	
					if flags == 1 && @@sel != nil && ip1.face != nil && @@face_addon == true
						add_object(@point)
					end

					select_comp=view.pick_helper
					select_comp.do_pick x,y
					selected_comp=select_comp.best_picked

					selected_face=select_comp.picked_face
					selected_face_mat=selected_face.material

					selection = Sketchup.active_model.selection
					sel_comp_status = selection.contains? selected_comp
					sel_face_status = selection.contains? selected_face

					# Add On Group 	
					if flags == 1 && @@sel != nil && @@group_addon == true && selected_comp.is_a?(Sketchup::Group) == true
						add_object(@point)
					end

					# Add On Component
					if flags == 1 && @@sel != nil && @@component_addon == true && selected_comp.is_a?(Sketchup::ComponentInstance) == true
						add_object(@point)
					end

					# Add On Image 	
					if flags == 1 && @@sel != nil && @@image_addon == true && selected_comp.is_a?(Sketchup::Image) == true
						add_object(@point)
					end

					# Add On Material 	
					if flags == 1 && @@sel != nil && @@material_addon == true && selected_face_mat != nil
						add_object(@point)
					end

					# Add On Texture
					if flags == 1 && @@sel != nil && @@texture_addon == true && selected_face_mat.texture != nil
						add_object(@point)
					end

					# Add On Selection
					if flags == 1 && @@sel != nil && @@sel_addon == true && sel_face_status == true
						add_object(point)
					end
					if flags == 1 && @@sel != nil && @@sel_addon == true && sel_comp_status == true
						add_object(@point)
					end
					
				end

			end #def



			def add_object(point)
				@@sel = Sketchup.active_model.selection[0]
				@@ents = Sketchup.active_model.active_entities

				@rrand = rand(@@rmax) + @@rmin
				@srand = rand(@@smax) + @@smin

				t1 = Geom::Transformation.rotation(ORIGIN, Z_AXIS, @rrand.degrees)
				t2 = Geom::Transformation.scaling @srand
				t3 = Geom::Transformation.new(point)

				if @@sel.is_a? Sketchup::ComponentInstance
					instance = @@ents.add_instance(@@sel.definition, t1)
					instance = instance.transform!(t2)
					instance = instance.transform!(t3)
				end

				if @@sel.is_a? Sketchup::Group
					defn = @@sel.entities.parent
					instance = @@ents.add_instance(defn, t1)
					instance = instance.transform!(t2)
					instance = instance.transform!(t3)
				end

				#Warinings
				if @@sel.is_a? Sketchup::ComponentInstance or @@sel.is_a? Sketchup::Group
					#working...
				else
					UI.messagebox("Before using tool select a 'Group' or 'Component'")
					Sketchup.send_action('selectSelectionTool:')
				end
			end #def



			def draw(view)
				point3 = Geom::Point3d.new(@point.x,@point.y,@point.z)
				view.draw_points(point3, 10, 1, "red")
			end #def

		end #class

	end #module

end #module

file_loaded( File.basename(__FILE__) )   # Mark the script loaded.